<!-- components/QueryInput.vue -->
<template>
  <div class="mb-4">
    <label for="query-input" class="block mb-2">Enter tree-sitter query:</label>
    <textarea id="query-input" rows="5" class="border p-2 rounded w-full"
      :class="{ 'bg-gray-800 text-white border-gray-700': isDarkMode }"
      @input="onInput" v-model="queryText"></textarea>
    <div class="mt-2" v-html="highlightedText"></div>
  </div>
</template>

<script lang="ts">
import init, { highlight } from 'highlight_wasm';
import { defineComponent, onMounted, ref, watch } from 'vue';

export default defineComponent({
  name: 'QueryInput',
  emits: ['query-changed'],
  props: {
    isDarkMode: {
      type: Boolean,
      required: true,
    },
    ranges: {
      type: Array,
      required: true,
    },
  },
  setup(props, { emit }) {
    const queryText = ref('');
    const highlightedText = ref('');
    const wasmLoaded = ref(false);

    const onInput = () => {
      if (wasmLoaded.value) {
        const highlighted = highlight(queryText.value, props.ranges);
        console.log(highlighted);
        highlightedText.value = highlighted;
      }
      emit('query-changed', queryText.value);
    };

    watch(queryText, (newQuery) => {
      if (wasmLoaded.value) {
        const highlighted = highlight(newQuery, props.ranges);
        highlightedText.value = highlighted;
      }
    });

    onMounted(async () => {
      await init();
      wasmLoaded.value = true;
      if (queryText.value) {
        const highlighted = highlight(queryText.value, props.ranges);
        highlightedText.value = highlighted;
      }
    });

    return {
      queryText,
      highlightedText,
      onInput,
    };
  },
});
</script>

<style scoped>
.bg-red-200 {
  background-color: #fed7d7;
}
.bg-yellow-200 {
  background-color: #fefcbf;
}
</style>